# coding: utf-8

"""
    AutoTec Services API

    API for methods pertaining to all AutoTec services  # noqa: E501

    OpenAPI spec version: 1.0.8
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from autotec.models.vehicle_risk_request_attribute import VehicleRiskRequestAttribute  # noqa: F401,E501


class RiskCalculationRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'type': 'str',
        'vehicle_risk_request_attributes': 'list[VehicleRiskRequestAttribute]'
    }

    attribute_map = {
        'type': 'type',
        'vehicle_risk_request_attributes': 'vehicleRiskRequestAttributes'
    }

    def __init__(self, type=None, vehicle_risk_request_attributes=None):  # noqa: E501
        """RiskCalculationRequest - a model defined in Swagger"""  # noqa: E501

        self._type = None
        self._vehicle_risk_request_attributes = None
        self.discriminator = None

        if type is not None:
            self.type = type
        self.vehicle_risk_request_attributes = vehicle_risk_request_attributes

    @property
    def type(self):
        """Gets the type of this RiskCalculationRequest.  # noqa: E501

        the risk prediction type  # noqa: E501

        :return: The type of this RiskCalculationRequest.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this RiskCalculationRequest.

        the risk prediction type  # noqa: E501

        :param type: The type of this RiskCalculationRequest.  # noqa: E501
        :type: str
        """
        allowed_values = ["Default", "CA", "FL", "SC"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def vehicle_risk_request_attributes(self):
        """Gets the vehicle_risk_request_attributes of this RiskCalculationRequest.  # noqa: E501

        the list of vehicle identification numbers/effective end date combinations  # noqa: E501

        :return: The vehicle_risk_request_attributes of this RiskCalculationRequest.  # noqa: E501
        :rtype: list[VehicleRiskRequestAttribute]
        """
        return self._vehicle_risk_request_attributes

    @vehicle_risk_request_attributes.setter
    def vehicle_risk_request_attributes(self, vehicle_risk_request_attributes):
        """Sets the vehicle_risk_request_attributes of this RiskCalculationRequest.

        the list of vehicle identification numbers/effective end date combinations  # noqa: E501

        :param vehicle_risk_request_attributes: The vehicle_risk_request_attributes of this RiskCalculationRequest.  # noqa: E501
        :type: list[VehicleRiskRequestAttribute]
        """
        if vehicle_risk_request_attributes is None:
            raise ValueError("Invalid value for `vehicle_risk_request_attributes`, must not be `None`")  # noqa: E501

        self._vehicle_risk_request_attributes = vehicle_risk_request_attributes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RiskCalculationRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
